#include <libnet.h>
#include "wu_error.h"
#include "wu_head.h"

int
wu_init_control()
{
    /*
     *  Heap memory for the control structure.
     */
    if (libnet_seed_prand() == -1)
    {
      wu_error(CRITICAL, "Can't initialize the random number generator\n");
      return (-1);
    }

    /*
     *  Initialize DEFAULTS, some of which we do not need
     */
    CNTRL.protocol = WU_DEF_PROTO; 
    CNTRL.opt_reading_wait.tv_sec = WU_DEF_OPT_R_SEC;
    CNTRL.opt_reading_wait.tv_usec = WU_DEF_OPT_R_USEC;
    CNTRL.opt_parprobes = WU_DEF_OPT_P;
    CNTRL.opt_probe_cnt = WU_DEF_PROBE;
    CNTRL.current_ttl = WU_DEF_CURRE;
    CNTRL.maxdepth = WU_DEF_MAXDE;
    CNTRL.timeout_depth = WU_DEF_TIMEO;

    CNTRL.ipdumpmode = 0;
    CNTRL.routers = NULL;	/* needs to be set at NULL */

    /*
     * how it is detwemined if router replies are equal:
     */
    CNTRL.sim_mask = WU_DEF_SIM_M;
    CNTRL.packtype = WU_DEF_PACKT;

    CNTRL.targets = NULL;

    CNTRL.scan_density = WU_DEF_SCAN_;
    CNTRL.subnet_resolution_mask = WU_DEF_SUBNE;
    CNTRL.mode = WU_DEF_MODE; 

    CNTRL._subnet_extra_depth = 0;
    return (1);
}

int
wu_shutdown()
{
    
  return (1);
}
