#include "./wu_error.h"
#include "./wu_head.h"
#include <stdarg.h>

extern char wu_debug;

void
wu_error(int severity, char *msg, ...)
{
  va_list ap;
  char buf[BUFSIZ];
  
  va_start(ap, msg);
  vsnprintf(buf, sizeof(buf) - 1, msg, ap);
  
  switch (severity)
    {
    case STDOUT:
      fprintf(stdout, "Note: "); 
      fprintf(stdout, "%s\n", buf);
      break;
    case WARNING:
      fprintf(stderr, "Warning: "); 
      fprintf(stderr, "%s\n", buf);
      break;
    case CRITICAL:
      fprintf(stderr, "Critical: ");
      fprintf(stderr, "%s\n", buf);
      break;
    case FATAL:
      fprintf(stderr, "Fatal: ");
      fprintf(stderr, "%s\n", buf);
      break;
    case VERBOSE:
      fprintf(stderr, "%s\n", buf);
      break;
    case DEBUG:
      if (wu_debug) {
	fprintf(stderr, "Debugging: ");
	fprintf(stderr, "%s\n", buf);
      }
      break;
    case DEBUG_MORE:
      if (wu_debug > 1) {
	fprintf(stderr, "Debugging: ");
	fprintf(stderr, "%s\n", buf);
      }
      break;
    case BUG:
      fprintf (stderr, "Runtime error: ");
	fprintf(stderr, "%s\n", buf);
       break;
    default:
      break;
    }
  

  va_end(ap);
  fflush(stderr);

  if (severity == FATAL)
    {
      exit(WEX_NO);
    }
}
