#include <stdio.h>
#include "wu_head.h"


#define _PING 0x1
#define _FARM 0x2
#define _NO_FARM 0x0


struct wu_reply * _make_farm_reply (WU_NODE * in) {
  IP size = in->range_h - in->range_l;
  int mask;
  struct wu_reply * farm = (struct wu_reply *) wmalloc (sizeof (struct wu_reply));

  if (size < 0) wu_error (BUG, "bug in _make_farm_reply");
  
  mask = maskbits_to_int(size);
  
  farm->respondent = new_ip2(htonl(in->range_l));
  farm->flag = /*WU_REPLY &*/ WU_FARM;
  farm->proto = 0;
  farm->packettype = 0;
  farm->farm_mask = mask;
  
  return farm;
}


struct routerlist * _make_farm (WU_NODE * in) {

  struct routerlist * foo = (struct routerlist *) wmalloc (sizeof (struct routerlist));

  foo->next = NULL;
  foo->reply = _make_farm_reply (in);
  return foo;
}


char _is_ping (WU_NODE * in) {
  struct routerlist * ptr;

  ptr = in->color;

  while (ptr != NULL) {
    if (ptr->reply->pingflag & PING_REPLY) return 1;
    ptr = ptr->next;
  }

  return 0;
}


int _find_farms (WU_NODE * in, struct iplist ** ips) {
#define _IN_IS_PING (_is_ping (in))

  int l;
  int r;
  struct iplist * llist = NULL;
  struct iplist * rlist = NULL;

  if (in == NULL) return  _NO_FARM;

  switch (in->flag) {
  case FLAG_AMAL:
    if (_IN_IS_PING) {
      *ips = ips_insert_list (*ips, in->reps);
      //possible memory leak
      return _PING;
    }
    else { return _NO_FARM; }
    break;
  case FLAG_OPEN:
    l = _find_farms (in->left, &llist);
    r = _find_farms (in->right, &rlist);
    if ((l & (_FARM | _PING)) && (r & (_FARM | _PING))) {
      in->reps = NULL;		/* should check if is null already */
      in->reps = ips_insert_list (in->reps, llist);
      in->reps = ips_insert_list (in->reps, rlist);
      in->flag = FLAG_AMAL;
      free_only_nodes(in->left);
      free_only_nodes(in->right);
      in->left = NULL;
      in->right = NULL;
      in->color = _make_farm (in);
      *ips = in->reps;
      return _FARM;
    }
    else if ( (l & _FARM) || (r & _FARM)) {
      *ips = ips_insert_list (*ips, llist);
      *ips = ips_insert_list (*ips, rlist);
      return _FARM;
    }
    else if ( (l & _PING) || (r & _PING)) {
      *ips = ips_insert_list (*ips, llist);
      *ips = ips_insert_list (*ips, rlist);
      return _PING;
    }
    break;
  case FLAG_UNREP:
    return _NO_FARM;
    break;
  }

  return _NO_FARM;
}


void find_farms (WU_NODE * in) {

  struct iplist * foo = NULL;
  _find_farms (in, &foo);
}
