				/* used for "re-aggregate" */
#include "wu_head.h"


WU_NODE * _amalgamate2 (WU_NODE * tree, int * res) 
{
  int foores;
  int fool;
  int foor;

  if (tree == NULL) { foores = 0; }
  else if (tree->flag == FLAG_AMAL) { foores = 1; }
  else if (tree->flag == FLAG_OPEN) {
    tree->left = _amalgamate2 (tree->left, &fool);
    tree->right = _amalgamate2 (tree->right, &foor);

    if (foor && fool) {
      tree->flag = FLAG_AMAL;
      tree->left = free_only_nodes (tree->left);
      tree->right = free_only_nodes (tree->right);
      foores = 1;
    }
    else { foores = 0; }
  }
  else {
    wu_error (BUG, "bad tree flag in function _amalgamate2");
  }
  *res = foores;
  return tree;
}		  


WU_NODE * amalgamate2 (WU_NODE * tree) { 
  int foo; 
  if (tree == NULL) return tree;
  _amalgamate2 (tree, &foo);

  return tree;
}


struct netlist * _new_netlist_from_tree (WU_NODE * tree, struct netlist * foo) {
  if (tree == NULL) return foo;

  if (tree->flag == FLAG_OPEN) {
    foo = _new_netlist_from_tree (tree->left, foo);
    foo = _new_netlist_from_tree (tree->right, foo);
  }
  else if (tree->flag == FLAG_AMAL) {
    foo = nets_insert (tree->range_l, tree->range_h, foo);
  }
  else {
    wu_error (BUG, "_new_netlsit_from_tree programmers fault");
  }
  return foo;
}


struct netlist * new_netlist_from_tree (WU_NODE * tree) {
  struct netlist * foo = NULL;
  foo = _new_netlist_from_tree (tree, foo);
  return foo;
}


WU_NODE * wu_insert2 (
		  IP range_l,	/* range INCLUDE range_l */
		  IP range_h,	/* range INCLUDES range_h */
		  IP min_range_l,
		  IP max_range_h,
		  WU_NODE * tree) {

  WU_NODE * new;
  int split;

  //split_range was not supposed to deal with ranges the same
  if (min_range_l == max_range_h) split = min_range_l;
  else split = split_range (min_range_l, max_range_h);

  wu_error (DEBUG_MORE, "wu_insert2 %s/%d",
	    libnet_host_lookup (htonl(range_l), 0),
	    maskbits_to_int (range_h - range_l));

  wu_error (DEBUG_MORE, "wu_insert2 span is%s/%d",
	    libnet_host_lookup (htonl(min_range_l), 0),
	    maskbits_to_int (max_range_h - min_range_l));

  if (tree == NULL) {/* insert at leaf */
    new = (WU_NODE *) wmalloc (sizeof (WU_NODE));
    new->range_l = min_range_l;
    new->range_h = max_range_h;
    new->flag = FLAG_OPEN;
    new->left = NULL;
    new->right = NULL;
    
    if ((range_l == min_range_l) && (range_h == max_range_h)) {
      new->flag = FLAG_AMAL;
      wu_error (DEBUG_MORE, "inserted at leaf");
    } 
    else if (range_l < split) {
      new->left = wu_insert2 (range_l , range_h, min_range_l, split - 1, new->left);
    }
    else {
      new->right = wu_insert2 (range_l, range_h, split, max_range_h, new->right);
    }
    return new;
  }
  else {
    wu_error (DEBUG_MORE, "inserting at stem...");
    if (tree->flag == FLAG_AMAL) {
      wu_error (BUG, "programmer error in \"wu_insert2()\", bad tree");
    }
    if ( (range_l < min_range_l) ||
	 (range_h > max_range_h) ) {
      wu_error (BUG, "error in \"wu_insert2()\", bad ranges");
    }
    if ( (range_l == min_range_l) &&
	 (range_h == max_range_h) ) {
      wu_error (BUG, "in \"wu_insert2()\", duplicate ranges");
    }
    if (range_l < split) {
      tree->left = wu_insert2 (range_l , range_h, min_range_l, split - 1, tree->left);
    }
    else {
      tree->right = wu_insert2 (range_l, range_h, split, max_range_h, tree->right);
    }
    return tree;
  }
  return NULL;		
}
