#include "wu_head.h"


extern char opt_dns;


IP2 new_ip2 (IP in) {
  IP2 new;
  new.ip_no = in;
  new.lookedup = 0;
  return new;
}


char * wu_lookup (IP2 * ip) {
  wu_error(DEBUG_MORE, "wu_lookup %s",
	   libnet_host_lookup (ip->ip_no, 0)	   );

  if (ip == NULL) wu_error (BUG, "wu_lookup called on null ip");

   if (ip->lookedup == 1) { 
     wu_error (DEBUG_MORE, "lookup up already cached %s...", ip->hostname); 
     return ip->hostname; 
   } 

  ip->hostname[0] = '\0';
  sprintf (	    ip->hostname,
		    //    WU_SMALL_STRING,
		    "%s",
		    libnet_host_lookup (ip->ip_no, opt_dns));

  ip->lookedup = 1;
  return ip->hostname;
}


char * wu_lookup_2 (IP2 * ip) {
  char * buf = (char *)wmalloc (sizeof (char) *(WU_SMALL_STRING + 1));

  if (ip == NULL) wu_error (BUG, "wu_lookup called on null ip");

   if (ip->lookedup == 1) { 
     goto jump;
   } 

  ip->hostname[0] = '\0';
  sprintf (	    ip->hostname,
		    //    WU_SMALL_STRING,
		    "%s",
		    libnet_host_lookup (ip->ip_no, opt_dns));

  ip->lookedup = 1;

 jump:
  if ( (! strcmp (libnet_host_lookup (ip->ip_no, 0), ip->hostname))
       || 
       (! opt_dns)
       ) 
    snprintf (buf, WU_SMALL_STRING, "%s", ip->hostname);
  else
    snprintf (buf, WU_SMALL_STRING, "%s (%s)", ip->hostname, libnet_host_lookup (ip->ip_no, 0));

  return buf;
}
