#include "wu_head.h"

extern char opt_heuristic;
extern char opt_farms;

struct wu_net * scan_multi (struct wu_net * toscan) {
  struct netlist * netptr;
  struct wu_net * res = NULL;   struct wu_net * tmplist = NULL;
  WU_NODE * tree;

  if (toscan == NULL) 
    wu_error (BUG, "in \"wu_net\", \"null net\"");

  netptr = toscan->nets;
  while (netptr != NULL) {

    ///make a wu_control or inherit it
    ///scan+amalgamate 
    CNTRL.cur_host = netptr->host;
    CNTRL.cur_mask = netptr->mask;

    wu_error (DEBUG_MORE, "scan_multi initiating scan of %s/%d",
	    libnet_host_lookup (CNTRL.cur_host, 0),
	    CNTRL.cur_mask);

    tree = wu_scan ();	
    
    amalgamate (tree);

    if (opt_farms)
      find_farms(tree);
    
    ///turn to netlist
    tmplist = node2list (tree, &tmplist);
    free_only_nodes (tree);

    ///add to res
    res = ordered_net_cat (res, tmplist);

    netptr = netptr->next;
  }

  ///do heuristic's on newnet
  wu_error (DEBUG_MORE, "doing heuristics");
  
  switch (opt_heuristic) {
  case WU_NONCONTIG:
    res = wu_noncontig_heuristic (res, CNTRL.sim_mask, CNTRL.packtype);
    break;
  case WU_ADJACENT:
    res = wu_adjacent_heuristic (res, CNTRL.sim_mask, CNTRL.packtype);
    break;
  case WU_ECMP:
    res = wu_ecmp_heuristic (res, CNTRL.sim_mask, CNTRL.packtype);
    break;
  default:
    break;
  }
  wu_error (DEBUG_MORE, "(done heristic)");

  wu_error (DEBUG_MORE, "re amalgamating");
   res = re_aggregate (res);
  wu_error (DEBUG_MORE, "(done re amalgamate)");

  //    debug_wu_net (res);

  return res;
}
