#include "wu_head.h"

extern char opt_verbose;

void _print_tracert ( struct wu_net * replies) {
  struct routerlist * routers = replies->routers;

  while (routers != NULL) {
    printf ("%s", wu_router_string (routers->reply));
    if (routers->next != NULL) printf (" ");
    routers = routers->next;
  }
  printf ("\n");
  return;
}


struct wu_net * _wu_tracert_do () {
  return node2list (wu_scan (), NULL);
}


void _wu_tracert ( int depth) {
  struct wu_net * replies;

  if (depth >= CNTRL.maxdepth) return;

  printf (" %d  ", CNTRL.current_ttl);
  printf ("%s", (CNTRL.current_ttl > 9) ? "" : " ");

  replies = _wu_tracert_do ();
  
  printf ("\n");

  wu_update_scan ();
  _wu_tracert ( depth + 1); /* n max not necessary though */
}


void _tracert_print () {

  printf ("tracert to %s from %d to %d hops\n",
	  libnet_host_lookup (CNTRL.base_host, 0),
	  CNTRL.current_ttl,
	  CNTRL.current_ttl + CNTRL.maxdepth - 1);
}

void wu_tracert () {
  if (opt_verbose)
    _tracert_print ();

  _wu_tracert ( 0);
  return;
}
